/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ActivityPatchableFile type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivityPatchableFile{}

// ActivityPatchableFile struct for ActivityPatchableFile
type ActivityPatchableFile struct {
	Name *string `json:"name,omitempty"`
	Url *string `json:"url,omitempty"`
	MimeType *string `json:"mime_type,omitempty"`
}

// NewActivityPatchableFile instantiates a new ActivityPatchableFile object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivityPatchableFile() *ActivityPatchableFile {
	this := ActivityPatchableFile{}
	return &this
}

// NewActivityPatchableFileWithDefaults instantiates a new ActivityPatchableFile object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivityPatchableFileWithDefaults() *ActivityPatchableFile {
	this := ActivityPatchableFile{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *ActivityPatchableFile) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivityPatchableFile) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *ActivityPatchableFile) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *ActivityPatchableFile) SetName(v string) {
	o.Name = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *ActivityPatchableFile) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivityPatchableFile) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *ActivityPatchableFile) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *ActivityPatchableFile) SetUrl(v string) {
	o.Url = &v
}

// GetMimeType returns the MimeType field value if set, zero value otherwise.
func (o *ActivityPatchableFile) GetMimeType() string {
	if o == nil || IsNil(o.MimeType) {
		var ret string
		return ret
	}
	return *o.MimeType
}

// GetMimeTypeOk returns a tuple with the MimeType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivityPatchableFile) GetMimeTypeOk() (*string, bool) {
	if o == nil || IsNil(o.MimeType) {
		return nil, false
	}
	return o.MimeType, true
}

// HasMimeType returns a boolean if a field has been set.
func (o *ActivityPatchableFile) HasMimeType() bool {
	if o != nil && !IsNil(o.MimeType) {
		return true
	}

	return false
}

// SetMimeType gets a reference to the given string and assigns it to the MimeType field.
func (o *ActivityPatchableFile) SetMimeType(v string) {
	o.MimeType = &v
}

func (o ActivityPatchableFile) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivityPatchableFile) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	if !IsNil(o.MimeType) {
		toSerialize["mime_type"] = o.MimeType
	}
	return toSerialize, nil
}

type NullableActivityPatchableFile struct {
	value *ActivityPatchableFile
	isSet bool
}

func (v NullableActivityPatchableFile) Get() *ActivityPatchableFile {
	return v.value
}

func (v *NullableActivityPatchableFile) Set(val *ActivityPatchableFile) {
	v.value = val
	v.isSet = true
}

func (v NullableActivityPatchableFile) IsSet() bool {
	return v.isSet
}

func (v *NullableActivityPatchableFile) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivityPatchableFile(val *ActivityPatchableFile) *NullableActivityPatchableFile {
	return &NullableActivityPatchableFile{value: val, isSet: true}
}

func (v NullableActivityPatchableFile) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivityPatchableFile) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


